### 5.2.5 Text Output

Text output is an important way that POV-Ray keeps you informed about what it is going to do, what it is doing and what it did. The program splits its text messages into 7 separate streams. Some versions of POV-Ray color-codes the various types of text. Some versions allow you to scroll back several pages of messages. All versions allow you to turn some of these text streams off/on or to direct a copy of the text output to one or several files. This section details the options which give you control over text output.

#### 5.2.5.1 Text Streams

There are seven distinct text streams that POV-Ray uses for output. On some versions each stream is designated by a particular color. Text from these streams are displayed whenever it is appropriate so there is often an intermixing of the text. The distinction is only important if you choose to turn some of the streams off or to direct some of the streams to text files. On some systems you may be able to review the streams separately in their own scroll-back buffer.

Here is a description of each stream.

Banner: This stream displays the program's sign-on banner, copyright, contributor's list, and some help screens. It cannot be turned off or directed to a file because most of this text is displayed before any options or switches are read. Therefore you cannot use an option or switch to control it. There are switches which display the help screens. They are covered in section "Help Screen Switches".

Debug: This stream displays debugging messages. It was primarily designed for developers but this and other streams may also be used by the user to display messages from within their scene files. See section "Text Message Streams" for details on this feature. This stream may be turned off and/or directed to a text file.

Fatal: This stream displays fatal error messages. After displaying this text, POV-Ray will terminate. When the error is a scene parsing error, you may be shown several lines of scene text that leads up to the error. This stream may be turned off and/or directed to a text file.

Render: This stream displays information about what options you have specified to render the scene. It includes feedback on all of the major options such as scene name, resolution, animation settings, anti-aliasing and others. This stream may be turned off and/or directed to a text file.

Statistics: This stream displays statistics after a frame is rendered. It includes information about the number of rays traced, the length of time of the processing and other information. This stream may be turned off and/or directed to a text file.

Status: This stream displays one-line status messages that explain what POV-Ray is doing at the moment. On some systems this stream is displayed on a status line at the bottom of the screen. This stream cannot be directed to a file because there is generally no need to. The text displayed by the `Verbose` option or `+V` switch is output to this stream so that part of the status stream may be turned off.

Warning: This stream displays warning messages during the parsing of scene files and other warnings. Despite the warning, POV-Ray can continue to render the scene. You will be informed if POV-Ray has made any assumptions about your scene so that it can proceed. In general any time you see a warning, you should also assume that this means that future versions of POV-Ray will not allow the warned action. Therefore you should attempt to eliminate warning messages so your scene will be able to run in future versions of POV-Ray. This stream may be turned off and/or directed to a text file.

#### 5.2.5.2 Console Text Output

`Debug_Console=`bool | Turn console display of debug info text on/off
`+GD` | Same as `Debug_Console=On`
`-GD` | Same as `Debug_Console=Off`
`Fatal_Console=`bool | Turn console display of fatal error text on/off
`+GF` | Same as `Fatal_Console=On`
`-GF` | Same as `Fatal_Console=Off`
`Render_Console=`bool | Turn console display of render info text on/off
`+GR` | Same as `Render_Console=On`
`-GR` | Same as `Render_Console=Off`
`Statistic_Console=`bool | Turn console display of statistic text on/off
`+GS` | Same as `Statistic_Console=On`
`-GS` | Same as `Statistic_Console=Off`
`Warning_Console=`bool | Turn console display of warning text on/off
`+GW` | Same as `Warning_Console=On`
`-GW` | Same as `Warning_Console=Off`
`All_Console=`bool | Turn on/off all debug, fatal, render, statistic and warning text to console.
`+GA` | Same as `All_Console=On`
`-GA` | Same as `All_Console=Off`

You may suppress the output to the console of the debug, fatal, render, statistic or warning text streams. For example the `Statistic_Console=off` option or the `-GS` switch can turn off the statistic stream. Using `on` or `+GS` you may turn it on again. You may also turn all five of these streams on or off at once using the `All_Console` option or `+GA` switch.

Note: that these options take effect immediately when specified. Obviously any error or warning messages that might occur before the option is read are not be affected.

#### 5.2.5.3 Directing Text Streams to Files

`Debug_File=true` | Echo debug info text to DEBUG.OUT
`Debug_File=false` | Turn off file output of debug info
`Debug_File=file` | Echo debug info text to file
`+GDfile` | Both `Debug_Console=On, Debug_File=file`
`-GDfile` | Both `Debug_Console=Off, Debug_File=file`
`Fatal_File=true` | Echo fatal text to FATAL.OUT
`Fatal_File=false` | Turn off file output of fatal
`Fatal_File=file` | Echo fatal info text to file
`+GFfile` | Both `Fatal_Console=On, Fatal_File=file`
`-GFfile` | Both `Fatal_Console=Off, Fatal_File=file`
`Render_File=true` | Echo render info text to RENDER.OUT
`Render_File=false` | Turn off file output of render info
`Render_File=`file | Echo render info text to file
`+GR`file | Both `Render_Console=On, Render_File=file`
`-GRfile` | Both `Render_Console=Off, Render_File=file`
`Statistic_File=true` | Echo statistic text to STATS.OUT
`Statistic_File=false` | Turn off file output of statistics
`Statistic_File=file` | Echo statistic text to file
`+GS`file | Both `Statistic_Console=On, Statistic_File=file`
`-GS`file | Both `Statistic_Console=Off, Statistic_File=file`
`Warning_File=true` | Echo warning info text to WARNING.OUT
`Warning_File=false` | Turn off file output of warning info
`Warning_File=file` | Echo warning info text to file
`+GWfile` | Both `Warning_Console=On, Warning_File=file`
`-GWfile` | Both `Warning_Console=Off, Warning_File=file`
`All_File=true` | Echo all debug, fatal, render, statistic, and warning text to ALLTEXT.OUT
`All_File=false` | Turn off file output of all debug, fatal, render, statistic, and warning text.
`All_File=file` | Echo all debug, fatal, render, statistic, and warning text to file
`+GAfile` | Both `All_Console=On, All_File=file`
`-GAfile` | Both `All_Console=Off, All_File=file`

You may direct a copy of the text streams to a text file for the debug, fatal, render, statistic, or warning text streams. For example the `Statistic_File`=s option or the `+GS` s switch. If the string s is `true` or any of the other valid `true` strings then that stream is redirected to a file with a default name. Valid `true` values are `true`, `yes`, `on` or `1`. If the value is `false` the direction to a text file is turned off. Valid `false` values are `false`, `no`, `off` or `0`. Any other string specified turns on file output and the string is interpreted as the output file name.

Similarly you may specify such a true, false or file name string after a switch such as `+GS` file. You may also direct all five streams to the same file using the `All_File` option or `+GA` switch. You may not specify the same file for two or more streams because POV-Ray will fail when it tries to open or close the same file twice.

Note: that these options take effect immediately when specified. Obviously any error or warning messages that might occur before the option is read will not be affected.

#### 5.2.5.4 Warning Level

`Warning_Level=n` | Allows you to turn off classes of warnings.
`+WLn` | Same as `Warning_Level=n`

Level 0 turns off all warnings. Level 5 turns off all language version related warnings. The default is level 10 and it enables all warnings. All other levels are reserved and should not be specified.

#### 5.2.5.5 Help Screen Switches

`+H` or `+?` | Show help screen 0 if this is the only switch

Note: there are no INI style equivalents to these options.

After displaying the help screens, POV-Ray terminates. Because some operating systems do not permit a question mark as a command line switch you may also use the `+H` switch.

Note: this switch is also used to specify the height of the image in pixels. Therefore the `+H` switch is only interpreted as a help switch if it is the only switch on the command line.

Graphical interface versions of POV-Ray such as Mac or Windows have extensive online help.